/*
 * this is healer, that heals patches
 * it merely takes the Result, treats it as a ResultPatch class
 * and peeks all the necessary data from the patches array:
 * patches[3*i] = offset 
 * patches[3*i+1] = origin
 * patches[3*i+2] = length of a patch
 */
package utils.tools;

import utils.av.*;
import utils.tools.patchhealer.*;

public class PatchHealer extends ZemskijFershal{
	public Result apply(Result prev){
		ResultPatch data = (ResultPatch)prev; // Class cast exception, if necessary
		byte [] healed = new byte [data.old_length];
		int i;
		for (i=0; i<healed.length; i++){
			healed[i]=data.file[i];
		}

		for (i=0; i<data.patches.length; ){
			int offset = data.patches[i++];
			int origin = data.patches[i++];
			int len = data.patches[i++];
			for (int j=0; j<len; j++){
				healed[j+offset]=data.file[j+origin];
			}
		}

		return new Result(prev.verdict, "GP", Result.HEALED, healed, true, null);
					// ^^^^^^ call GP again, to check for
					// more viruses; true = truly modified
	}

}
